package chatserver;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.IOException;
import java.util.List;
import java.util.Collections;
import java.util.ArrayList;

public class ChatServer{
  public static List<ChatServerCThread> usersList = Collections.synchronizedList(new ArrayList<>(100));
  
  public static void main(String[] args){
    ServerSocket ss = null;
    try{
      ss = new ServerSocket(5000);
    }
    catch(IOException e){
      System.out.println("Can't start server");
      return;
    }
    while(true){
      System.out.println("Waiting for next client...");
      Socket s = null;
      try{
        s = ss.accept();
        System.out.println("Client connected! Starting thread...");
        ChatServerCThread t = new ChatServerCThread(s);
        t.start();
      }
      catch(IOException e){}
    }
  }
  
  public static void sendToAll(String msg){
    for(int i=0; i<ChatServer.usersList.size(); i++){
      try{
        ChatServer.usersList.get(i).send(msg);
      }
      catch(IOException e){
        ChatServer.usersList.get(i).interrupt();
        ChatServer.usersList.remove(i);
      }
    }
  }
}