package chatserver;
import java.net.Socket;
import java.io.IOException;
import java.io.DataInputStream;
import java.io.DataOutputStream;

public class ChatServerCThread extends Thread{
  Socket sock;
  DataInputStream in;
  DataOutputStream out;
  String name;
  
  public ChatServerCThread(Socket sock){
    this.sock = sock;
  }
  public void run(){
    try{
      this.in = new DataInputStream(this.sock.getInputStream());
      this.out = new DataOutputStream(this.sock.getOutputStream());
      this.out.flush();
      this.out.writeUTF("Hello. Please send your username...");
      this.out.flush();
      this.name = in.readUTF();
    }
    catch(IOException e){
      System.out.println("Problem with client thread."+e.getMessage());
      this.disconnect();
      return;
    }
    ChatServer.usersList.add(this);
    String msg = null;
    do{
      try{
        msg = this.in.readUTF();
        ChatServer.sendToAll(this.name+": "+msg);
      }
      catch(IOException e){
        System.out.println("Problem reading from "+this.name);
        this.disconnect();
        return;
      }
    }
    while(!msg.equals("exit"));
    this.disconnect();
  }
  
  public void disconnect(){
    try{
      if(this.sock!=null) this.sock.close();
    }
    catch(IOException e){}
    // find and delete me from clients list
    for(int i=0; i<ChatServer.usersList.size(); i++){
      if(ChatServer.usersList.get(i).equals(this)){
        ChatServer.usersList.remove(i);
        return;      
      }
    }
  }
  
  public synchronized void send(String msg) throws IOException{
    this.out.writeUTF(msg);
    this.out.flush();
  }
}